searchNodes=[{"doc":"Runs the linter. &gt; mix recode [options] [inputs] Without a inputs argument the inputs value from the config is used. The inputs argument accepts a wildcard. If inputs value is - , then the input is read from stdin. Without the option --config file the config file .recode.exs is used. A default .recode.exs can be generated with mix recode.gen.config . Command line Option --autocorrect , --no-autocorrect - Activates/deactivates autocrrection. Overwrites the corresponding value in the configuration. --config - specifies an alternative config file. --dry , --no-dry - Activates/deactivates the dry mode. No file is overwritten in dry mode. Overwrites the corresponding value in the configuration. --verbose , --no-verbose - Activate/deactivates the verbose mode. Overwrites the corresponding value in the configuration. --task , specifies the task to use. With this option, the task is used even if it is specified as active: false in the configuration.","ref":"Mix.Tasks.Recode.html","title":"Mix.Tasks.Recode","type":"task"},{"doc":"Generates a new config for Recode. Writes the file .recode.exs in the root directory of the mix project. The default config: alias Recode.Task [ version : &quot;0.4.4&quot; , # Can also be set/reset with &quot;--autocorrect&quot;/&quot;--no-autocorrect&quot;. autocorrect : true , # With &quot;--dry&quot; no changes will be written to the files. # Can also be set/reset with &quot;--dry&quot;/&quot;--no-dry&quot;. # If dry is true then verbose is also active. dry : false , # Can also be set/reset with &quot;--verbose&quot;/&quot;--no-verbose&quot;. verbose : false , # Can be overwriten by calling `mix recode &quot;lib/**/*.ex&quot;`. inputs : [ &quot;{apps,config,lib,test}/**/*.{ex,exs}&quot; ] , formatter : { Recode.Formatter , [ ] } , tasks : [ # Tasks could be added by a tuple of the tasks module name and an options # keyword list. A task can be deactived by `active: false`. The execution of # a deactivated task can be forced by calling `mix recode --task ModuleName`. { Task.AliasExpansion , [ ] } , { Task.AliasOrder , [ ] } , { Task.EnforceLineLength , active : false } , { Task.PipeFunOne , [ ] } , { Task.SinglePipe , [ ] } , { Task.Specs , exclude : &quot;test/**/*.{ex,exs}&quot; , config : [ only : :visible ] } , { Task.TestFileExt , [ ] } , { Task.UnusedVariable , active : false } ] ]","ref":"Mix.Tasks.Recode.Gen.Config.html","title":"Mix.Tasks.Recode.Gen.Config","type":"task"},{"doc":"A linter with autocorrection and a refactoring tool.","ref":"Recode.html","title":"Recode","type":"module"},{"doc":"This module provides functions to get informations from the AST and to manipulate the AST. Most of the functions in this module require an AST with additional informations. This information is provided by Sourceror or Code.string_to_quoted/2 with the options [ columns : true , literal_encoder : &amp; { :ok , { :__block__ , &amp;2 , [ &amp;1 ] } } , token_metadata : true , unescape : false ] See also Formatting considerations in the docs for Code.quoted_to_algebra/2 . This module provides literal? functions that are also work with encoded literals generate by literal_encoder: %{:ok, {:__block__, &amp;2, [&amp;1]}} . For an example see atom?/1 .","ref":"Recode.AST.html","title":"Recode.AST","type":"module"},{"doc":"Returns the infos from an AST representing an alias expression. The function returns 3-tuple containing the alias, the multi part and the :as . Examples iex&gt; ast = quote do ...&gt; alias Foo.Bar ...&gt; end iex&gt; alias_info ( ast ) { Foo.Bar , [ ] , nil } iex&gt; ast = quote do ...&gt; alias Foo . { Bar , Baz } ...&gt; end iex&gt; alias_info ( ast ) { Foo , [ Bar , Baz ] , nil } iex&gt; ast = quote do ...&gt; alias Foo , as : Baz ...&gt; end iex&gt; alias_info ( ast ) { Foo , [ ] , Baz }","ref":"Recode.AST.html#alias_info/1","title":"Recode.AST.alias_info/1","type":"function"},{"doc":"Concatinates the aliases of an :__aliases__ tuple. Examples iex&gt; aliases_concat ( { :__aliases__ , [ ] , [ :Alpha , :Bravo ] } ) Alpha.Bravo","ref":"Recode.AST.html#aliases_concat/1","title":"Recode.AST.aliases_concat/1","type":"function"},{"doc":"Returns true if the given AST represents an atom. Examples iex&gt; &quot;:atom&quot; |&gt; Code . string_to_quoted! ( ) |&gt; atom? ( ) true iex&gt; &quot;:atom&quot; |&gt; Sourceror . parse_string! ( ) |&gt; atom? ( ) true iex&gt; &quot;42&quot; |&gt; Sourceror . parse_string! ( ) |&gt; atom? ( ) false iex&gt; ast = Code . string_to_quoted! ( ...&gt; &quot;:a&quot; , literal_encoder : &amp; { :ok , { :__block__ , &amp;2 , [ &amp;1 ] } } ) { :__block__ , [ line : 1 ] , [ :a ] } iex&gt; atom? ( ast ) true","ref":"Recode.AST.html#atom?/1","title":"Recode.AST.atom?/1","type":"function"},{"doc":"Returns the line in which the given AST starts. Note: The AST must be constructed by Sourceror or with the Code module and the options columns: true, token_metadata: true . Examples iex&gt; code = &quot;&quot;&quot; ...&gt; 1 + ...&gt; 2 - ...&gt; 3 ...&gt; &quot;&quot;&quot; iex&gt; code |&gt; Sourceror . parse_string! ( ) |&gt; first_line ( ) 1 iex&gt; code |&gt; Sourceror . parse_string! ( ) |&gt; last_line ( ) 3 iex&gt; code ...&gt; |&gt; Code . string_to_quoted! ( ...&gt; columns : true , ...&gt; token_metadata : true , ...&gt; literal_encoder : &amp; { :ok , { :__block__ , &amp;2 , [ &amp;1 ] } } ) ...&gt; |&gt; last_line ( ) 3","ref":"Recode.AST.html#first_line/1","title":"Recode.AST.first_line/1","type":"function"},{"doc":"Returns the newlines value from meta[:end_of_expression] , or nil .","ref":"Recode.AST.html#get_newlines/1","title":"Recode.AST.get_newlines/1","type":"function"},{"doc":"Returns the value from a :__block__ with a single argument. Examples iex&gt; &quot;[1, 2]&quot; ...&gt; |&gt; Sourceror . parse_string! ( ) ...&gt; |&gt; get_value ( ) ...&gt; |&gt; Enum . map ( &amp; get_value / 1 ) [ 1 , 2 ]","ref":"Recode.AST.html#get_value/1","title":"Recode.AST.get_value/1","type":"function"},{"doc":"","ref":"Recode.AST.html#last_line/1","title":"Recode.AST.last_line/1","type":"function"},{"doc":"Returns a mfa -tuple for the given . -call.","ref":"Recode.AST.html#mfa/1","title":"Recode.AST.mfa/1","type":"function"},{"doc":"Returns true when the given ast represents an expression that spans over multiple lines. multiline? does not pay attention to do blocks. Examples iex&gt; &quot;&quot;&quot; ...&gt; def foo(x) ...&gt; when is_integer(x) do ...&gt; {:foo, x} ...&gt; end ...&gt; &quot;&quot;&quot; ...&gt; |&gt; Sourceror . parse_string! ( ) |&gt; multiline? ( ) true iex&gt; &quot;&quot;&quot; ...&gt; def foo(x) when is_integer(x) do ...&gt; {:foo, x} ...&gt; end ...&gt; &quot;&quot;&quot; ...&gt; |&gt; Sourceror . parse_string! ( ) |&gt; multiline? ( ) false iex&gt; &quot;&quot;&quot; ...&gt; { ...&gt; x, ...&gt; y ...&gt; } ...&gt; &quot;&quot;&quot; ...&gt; |&gt; Sourceror . parse_string! ( ) |&gt; multiline? ( ) true iex&gt; &quot;&quot;&quot; ...&gt; {x, y} ...&gt; &quot;&quot;&quot; ...&gt; |&gt; Sourceror . parse_string! ( ) |&gt; multiline? ( ) false","ref":"Recode.AST.html#multiline?/1","title":"Recode.AST.multiline?/1","type":"function"},{"doc":"Converts AST representing a name to a string. This function suppresses the prefix &quot;Elixir.&quot; . Examples iex&gt; name ( [ Recode , AST ] ) &quot;Recode.AST&quot; iex&gt; name ( Recode.AST ) &quot;Recode.AST&quot;","ref":"Recode.AST.html#name/1","title":"Recode.AST.name/1","type":"function"},{"doc":"Puts the given value newlines under the key nevlines in meta[:end_of_expression] .","ref":"Recode.AST.html#put_newlines/2","title":"Recode.AST.put_newlines/2","type":"function"},{"doc":"Puts the given value in the :__block__ AST. Examples iex&gt; &quot;[1, 2]&quot; ...&gt; |&gt; Sourceror . parse_string! ( ) ...&gt; |&gt; get_value ( ) ...&gt; |&gt; Enum . map ( fn ast -&gt; put_value ( ast , &quot;0&quot; ) end ) ...&gt; |&gt; Enum . map ( &amp; get_value / 1 ) [ &quot;0&quot; , &quot;0&quot; ]","ref":"Recode.AST.html#put_value/2","title":"Recode.AST.put_value/2","type":"function"},{"doc":"","ref":"Recode.AST.html#to_same_line/1","title":"Recode.AST.to_same_line/1","type":"function"},{"doc":"Update a function call. The keyword list updates can have the keys name , meta and args . Examples iex&gt; quote do ...&gt; foo ( x ) ...&gt; end ...&gt; |&gt; update_call ( name : :bar ) ...&gt; |&gt; Macro . to_string ( ) &quot;bar(x)&quot;","ref":"Recode.AST.html#update_call/2","title":"Recode.AST.update_call/2","type":"function"},{"doc":"Updates the function name of a capture.","ref":"Recode.AST.html#update_capture/2","title":"Recode.AST.update_capture/2","type":"function"},{"doc":"Updates the AST representing a definition. The keyword list updates can have the keys name , meta and args . Examples iex&gt; ast = Sourceror . parse_string! ( &quot;def foo(x), do: x&quot; ) iex&gt; ast |&gt; update_definition ( name : :bar ) |&gt; Macro . to_string ( ) &quot;def bar(x), do: x&quot; iex&gt; ast |&gt; update_definition ( args : [ { :y , [ ] , nil } ] ) |&gt; Macro . to_string ( ) &quot;def foo(y), do: x&quot;","ref":"Recode.AST.html#update_definition/2","title":"Recode.AST.update_definition/2","type":"function"},{"doc":"Update a dotted function call. Examples iex&gt; ast = quote do ...&gt; Foo . foo ( x ) ...&gt; end iex&gt; update_dot_call ( ast , name : :bar ) { { :. , [ ] , [ { :__aliases__ , [ alias : false ] , [ :Foo ] } , :bar ] } , [ ] , [ { :x , [ ] , Recode.ASTTest } ] }","ref":"Recode.AST.html#update_dot_call/2","title":"Recode.AST.update_dot_call/2","type":"function"},{"doc":"Updates a spec. The keyword list updates can have the keys name , meta , args and return . Examples iex&gt; quote do ...&gt; @spec foo ( integer ( ) ) :: integer ( ) ...&gt; end ...&gt; |&gt; update_spec ( name : :bar , return : { :term , [ ] , [ ] } ) ...&gt; |&gt; Macro . to_string ( ) &quot;@spec bar(integer()) :: term()&quot;","ref":"Recode.AST.html#update_spec/2","title":"Recode.AST.update_spec/2","type":"function"},{"doc":"This module reads the Recode configuration.","ref":"Recode.Config.html","title":"Recode.Config","type":"module"},{"doc":"","ref":"Recode.Config.html#read/1","title":"Recode.Config.read/1","type":"function"},{"doc":"","ref":"Recode.Config.html#validate/1","title":"Recode.Config.validate/1","type":"function"},{"doc":"","ref":"Recode.Config.html#validate/2","title":"Recode.Config.validate/2","type":"function"},{"doc":"","ref":"Recode.Config.html#t:config/0","title":"Recode.Config.config/0","type":"type"},{"doc":"This module provides functions to traverse an AST with a %Context{} . Examples The following example shows the %Context{} for the definition of MyApp.Bar.bar/1 . iex&gt; alias Rewrite.Source ...&gt; alias Recode.Context ...&gt; &quot;&quot;&quot; ...&gt; defmodule MyApp.Foo do ...&gt; def foo, do: :foo ...&gt; end ...&gt; ...&gt; defmodule MyApp.Bar do ...&gt; alias MyApp.Foo ...&gt; ...&gt; def bar(x) do ...&gt; {Foo.foo(), x} ...&gt; end ...&gt; end ...&gt; &quot;&quot;&quot; ...&gt; |&gt; Source . from_string ( ) ...&gt; |&gt; Source . ast ( ) ...&gt; |&gt; Zipper . zip ( ) ...&gt; |&gt; Context . traverse ( nil , fn ...&gt; zipper , context , nil -&gt; ...&gt; case context . definition do ...&gt; { { :def , :bar , 1 } , _meta } -&gt; { zipper , context , context } ...&gt; _def -&gt; { zipper , context , nil } ...&gt; end ...&gt; zipper , context , acc -&gt; ...&gt; { zipper , context , acc } ...&gt; end ) ...&gt; |&gt; elem ( 1 ) |&gt; Map . put ( :node , nil ) % Context { node : nil , aliases : [ { MyApp.Foo , [ trailing_comments : [ ] , leading_comments : [ ] , end_of_expression : [ newlines : 2 , line : 6 , column : 18 ] , line : 6 , column : 3 ] , nil } ] , assigns : %{ } , definition : { { :def , :bar , 1 } , [ trailing_comments : [ ] , leading_comments : [ ] , do : [ line : 8 , column : 14 ] , end : [ line : 10 , column : 3 ] , line : 8 , column : 3 ] } , imports : [ ] , module : { MyApp.Bar , [ trailing_comments : [ ] , leading_comments : [ ] , do : [ line : 5 , column : 21 ] , end : [ line : 11 , column : 1 ] , line : 5 , column : 1 ] } , requirements : [ ] , usages : [ ] }","ref":"Recode.Context.html","title":"Recode.Context","type":"module"},{"doc":"Assigns the given value under key to the context .","ref":"Recode.Context.html#assign/3","title":"Recode.Context.assign/3","type":"function"},{"doc":"Merges the given map to the assigns of the context .","ref":"Recode.Context.html#assigns/2","title":"Recode.Context.assigns/2","type":"function"},{"doc":"Returns true if definition satisfies the assumption.","ref":"Recode.Context.html#definition?/2","title":"Recode.Context.definition?/2","type":"function"},{"doc":"Returns true if @doc is available and not set to @doc false .","ref":"Recode.Context.html#doc?/1","title":"Recode.Context.doc?/1","type":"function"},{"doc":"Returns true if @doc false .","ref":"Recode.Context.html#doc?/2","title":"Recode.Context.doc?/2","type":"function"},{"doc":"Expands the module alias for the given mfa .","ref":"Recode.Context.html#expand_mfa/2","title":"Recode.Context.expand_mfa/2","type":"function"},{"doc":"Returns true if an impl is available.","ref":"Recode.Context.html#impl?/1","title":"Recode.Context.impl?/1","type":"function"},{"doc":"Returns the current module of a context.","ref":"Recode.Context.html#module/1","title":"Recode.Context.module/1","type":"function"},{"doc":"Returns true if @moduledoc is available and not set to @moduledoc false .","ref":"Recode.Context.html#moduledoc?/1","title":"Recode.Context.moduledoc?/1","type":"function"},{"doc":"Returns true if @moduledoc false .","ref":"Recode.Context.html#moduledoc?/2","title":"Recode.Context.moduledoc?/2","type":"function"},{"doc":"Returns true if a spec is available.","ref":"Recode.Context.html#spec?/1","title":"Recode.Context.spec?/1","type":"function"},{"doc":"Traverses the given zipper and applies fun on each node. The fun gets the current zipper and context as arguments.","ref":"Recode.Context.html#traverse/2","title":"Recode.Context.traverse/2","type":"function"},{"doc":"Traverses the given zipper with an acc and applies fun on each node.","ref":"Recode.Context.html#traverse/3","title":"Recode.Context.traverse/3","type":"function"},{"doc":"","ref":"Recode.Context.html#t:t/0","title":"Recode.Context.t/0","type":"type"},{"doc":"","ref":"Recode.Context.html#t:zipper/0","title":"Recode.Context.zipper/0","type":"type"},{"doc":"The default formatter and the formatter bebaviour.","ref":"Recode.Formatter.html","title":"Recode.Formatter","type":"behaviour"},{"doc":"","ref":"Recode.Formatter.html#format/3","title":"Recode.Formatter.format/3","type":"function"},{"doc":"","ref":"Recode.Formatter.html#c:format/3","title":"Recode.Formatter.format/3","type":"callback"},{"doc":"","ref":"Recode.Formatter.html#format/4","title":"Recode.Formatter.format/4","type":"function"},{"doc":"","ref":"Recode.Formatter.html#c:format/4","title":"Recode.Formatter.format/4","type":"callback"},{"doc":"Defines Recode formatter plugin for mix format . Since Elixir 1.13, it is possible to define custom formatter plugins. This plugin allows you to run Recode autocorrecting tasks together when executing mix format . To use this formatter, simply add Recode.FormatterPlugin to your .formatter.exs plugins: [ inputs : [ &quot;{mix,.formatter}.exs&quot; , &quot;{config,lib,test}/**/*.{ex,exs}&quot; ] , plugins : [ Recode.FormatterPlugin ] ] By default it uses the .recode.exs configuration file. If your project does not have a .recode.exs configuration file or if you want to overwrite the configuration, you can pass the configuration using the recode option: [ inputs : [ &quot;{mix,.formatter}.exs&quot; , &quot;{config,lib,test}/**/*.{ex,exs}&quot; ] , plugins : [ Recode.FormatterPlugin ] , recode : [ tasks : [ { Recode.Task.AliasExpansion , [ ] } , { Recode.Task.EnforceLineLength , [ ] } , { Recode.Task.SinglePipe , [ ] } ] ] ]","ref":"Recode.FormatterPlugin.html","title":"Recode.FormatterPlugin","type":"module"},{"doc":"This module provides IO functions and contains the color schema for Recode .","ref":"Recode.IO.html","title":"Recode.IO","type":"module"},{"doc":"Similar to write/1 , but adds a newline at the end.","ref":"Recode.IO.html#puts/1","title":"Recode.IO.puts/1","type":"function"},{"doc":"See IO.ANSI.reverse/0 .","ref":"Recode.IO.html#reverse/0","title":"Recode.IO.reverse/0","type":"function"},{"doc":"See IO.ANSI.reverse_off/0 .","ref":"Recode.IO.html#reverse_off/0","title":"Recode.IO.reverse_off/0","type":"function"},{"doc":"Formats a chardata-like argument by converting named ANSI sequences into actual ANSI codes and writes it to :stdio .","ref":"Recode.IO.html#write/1","title":"Recode.IO.write/1","type":"function"},{"doc":"","ref":"Recode.IO.html#t:chardata/0","title":"Recode.IO.chardata/0","type":"type"},{"doc":"","ref":"Recode.IO.html#t:color/0","title":"Recode.IO.color/0","type":"type"},{"doc":"An Issue struct to track findings by the chechers.","ref":"Recode.Issue.html","title":"Recode.Issue","type":"module"},{"doc":"Creates a new %Issue{} Examples iex&gt; Recode.Issue . new ( Test , &quot;kaput&quot; , line : 1 , column : 1 ) % Recode.Issue { reporter : Test , message : &quot;kaput&quot; , line : 1 , column : 1 , meta : nil } iex&gt; Recode.Issue . new ( Test , foo : &quot;bar&quot; ) % Recode.Issue { reporter : Test , message : nil , line : nil , column : nil , meta : [ foo : &quot;bar&quot; ] }","ref":"Recode.Issue.html#new/4","title":"Recode.Issue.new/4","type":"function"},{"doc":"","ref":"Recode.Issue.html#t:t/0","title":"Recode.Issue.t/0","type":"type"},{"doc":"The behaviour for a recode task.","ref":"Recode.Task.html","title":"Recode.Task","type":"behaviour"},{"doc":"Returns the configuration for the given key .","ref":"Recode.Task.html#c:config/1","title":"Recode.Task.config/1","type":"callback"},{"doc":"Applies a task with the given source and opts .","ref":"Recode.Task.html#c:run/2","title":"Recode.Task.run/2","type":"callback"},{"doc":"This module provides utility functions for recode .","ref":"Recode.Utils.html","title":"Recode.Utils","type":"module"},{"doc":"Returns true id value ends with suffix . Both, value and suffix must be lists or module aliases. Examples iex&gt; Recode.Utils . ends_with? ( Foo.Bar , Bar ) true iex&gt; Recode.Utils . ends_with? ( Foo , Foo.Bar ) false iex&gt; Recode.Utils . ends_with? ( Foo.Bar , Baz ) false iex&gt; Recode.Utils . ends_with? ( [ 1 , 2 , 3 ] , [ 2 , 3 ] ) true iex&gt; Recode.Utils . ends_with? ( [ 1 , 2 , 3 ] , [ 2 , 9 ] ) false","ref":"Recode.Utils.html#ends_with?/2","title":"Recode.Utils.ends_with?/2","type":"function"},{"doc":"Multi aliases makes module uses harder to search for in large code bases. # preferred alias Module.Foo alias Module.Bar # not preferred alias Module . { Foo , Bar } This task rewrites the code when mix recode runs with autocorrect: true .","ref":"Recode.Task.AliasExpansion.html","title":"Recode.Task.AliasExpansion","type":"module"},{"doc":"Alphabetically sorted lists are easier to read. # preferred alias Alpha alias Bravo alias Delta . { Echo , Foxtrot } # not preferred alias Delta . { Foxtrot , Echo } alias Alpha alias Bravo","ref":"Recode.Task.AliasOrder.html","title":"Recode.Task.AliasOrder","type":"module"},{"doc":"The EnforceLineLength task writes multiline expressions into one line if they do not exceed the maximum line length. Options :skip - specifies expressions to skip. :ignore - specifies expressions to ignore. Examples The following code is not changed by the Elixir Formatter. fn x -&gt; { :ok, x } end The EnforceLineLength task rewrite this to fn x -&gt; {:ok, x} end and with the option [ignore: :fn] to fn x -&gt; {:ok, x} end and with the option skip: :fn the code keeps unchanged.","ref":"Recode.Task.EnforceLineLength.html","title":"Recode.Task.EnforceLineLength","type":"module"},{"doc":"This task runs the Elixir formatter. This task runs as first task by any mix recode call.","ref":"Recode.Task.Format.html","title":"Recode.Task.Format","type":"module"},{"doc":"Add parentheses to one-arity functions. # preferred some_string |&gt; String . downcase ( ) |&gt; String . trim ( ) # not preferred some_string |&gt; String . downcase |&gt; String . trim This task rewrites the code when mix recode runs with autocorrect: true .","ref":"Recode.Task.PipeFunOne.html","title":"Recode.Task.PipeFunOne","type":"module"},{"doc":"Pipes ( |&gt; ) should only be used when piping data through multiple calls. # preferred some_string |&gt; String . downcase ( ) |&gt; String . trim ( ) Enum . reverse ( some_enum ) # not preferred some_enum |&gt; Enum . reverse ( ) SinglePipe does not change a single |&gt; that starts with a none zero arity function. # will not be changed one ( :a ) |&gt; two ( ) This task rewrites the code when mix recode runs with autocorrect: true .","ref":"Recode.Task.SinglePipe.html","title":"Recode.Task.SinglePipe","type":"module"},{"doc":"Function should have specs. Options :only - :public , :visible :macros - when true , macros are also checked, defaults to false .","ref":"Recode.Task.Specs.html","title":"Recode.Task.Specs","type":"module"},{"doc":"Tests must be in a file with the extension *_test.exs . This module searches for *_test.ex to rename the file and/or report an issue.","ref":"Recode.Task.TestFileExt.html","title":"Recode.Task.TestFileExt","type":"module"},{"doc":"Prepend unused variables with _","ref":"Recode.Task.UnusedVariable.html","title":"Recode.Task.UnusedVariable","type":"module"}]